"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * 如果添加的模块只需要拷贝文件，那么继承该类就可以了
 * @Author: Wheeler
 * @Date: 2020-05-26 17:00:43
 * @FilePath: /sails-model-generator/src/features/FileCopyFeature.ts
 */
const FeatureAdapter_1 = __importDefault(require("./FeatureAdapter"));
const fs_extra_1 = __importDefault(require("fs-extra"));
const path_1 = __importDefault(require("path"));
const colors_1 = __importDefault(require("colors"));
const FSUtils_1 = __importDefault(require("../FSUtils"));
class FileCopyFeature extends FeatureAdapter_1.default {
    generate() {
        let dir = path_1.default.join(__dirname, `../../templates/features/${this.name()}`);
        let files = FSUtils_1.default.getFiles(dir);
        let existsFiles = [];
        for (let file of files) {
            let f = file.replace(dir, '');
            let exists = fs_extra_1.default.existsSync(path_1.default.join(process.cwd(), f));
            if (exists) {
                existsFiles.push(f);
            }
        }
        if (existsFiles.length > 0) {
            return console.log(colors_1.default.error('以下文件已经存在，请检查。\n' + existsFiles.join('\n')));
        }
        fs_extra_1.default.copySync(dir, process.cwd());
        console.log(colors_1.default.success('添加成功，以下文件已经添加到项目中:\n' + files.join('\n')));
        if (this.resources().length > 0) { //需要添加权限
            console.log(colors_1.default.info('请将以下权限添加到系统中:\n' + this.resources().join('\n')));
        }
    }
}
exports.default = FileCopyFeature;
